#define _CRT_SECURE_NO_DEPRECATE
#include <iostream> 
#include <string>
#include <vector>
#include <sstream>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <math.h>
#include <stack>
#include <deque>
#include <numeric>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <bitset>

#define mpair make_pair
#define all(v) v.begin(),v.end()
using namespace std;
typedef long long ll;
typedef long double ld;
const ld epsylon = 1e-9;
typedef unsigned int ui;
#ifndef WIN32
#include <sys/time.h>
#else
#include <windows.h>
#include <time.h>
#endif

inline long double get_time(){    
#ifndef WIN32
	timeval tv;
	gettimeofday(&tv, 0);
	return tv.tv_sec + tv.tv_usec/1000000.0 ;
#else
	return (long double)clock()/CLOCKS_PER_SEC;
#endif
};
struct myRandom{
	ui mat[624];
	int index;
	myRandom(int seed){
		reseed(seed);
	}
	ui randomBits() {
		if(index == 0) {
			refillArray();
		}
		ui y = mat[index];
		y ^= (y>>11);
		y ^= ((y<<7)&2636928640U);
		y ^= ((y<<15)&4022730752U);
		y ^= (y>>18);
		index = (index + 1)%624;
		return y;
	}
	void reseed(ui seed){
		mat[0] = seed;
		for(int i=1;i<624;i++){
			mat[i] = 1812433253ULL*((mat[i-1]^(mat[i-1]>>30)) + i);
		}
		index = 0;
	}
	inline int rnd(ui mod){
		return randomBits()%mod;
	}
	void refillArray() {
		for(int i=0;i<624;i++) {
			ui upper = 1<<31;
			ui lower = upper-1;
			ui y = mat[i]&upper + mat[(i+1)%624]&lower;
			mat[i] = mat[(i + 397) % 624] ^ (y>>1);
			if (y & 1){ 
				mat[i] ^= 2567483615U;
			}
		}
	}
};
myRandom rander(43);
struct piramida {
	piramida(int max_val) {
		size_ = 0;
		h.resize(max_val + 1);
		rev.resize(max_val  + 1);
		for (int i=0;i<max_val;++i) {
			size_++;
			h[size_] = mpair(0, i);
			rev[i] = size_;
		}
	}
	void sift_up(int index) {
		while (index > 1 && h[index].first > h[index/2].first) {
			swap(rev[h[index].second], rev[h[index/2].second]);
			swap(h[index], h[index/2]);
			index /= 2;
		}
	}
	void sink_down(int index) {
		while (index*2 <= size_) {
			int t = index*2;
			if (t + 1 <=size_ && h[t+1].first > h[t].first) {
				t++;
			}
			if (h[t].first <= h[index].first) {
				break;
			}
			swap(rev[h[index].second], rev[h[t].second]);
			swap(h[index], h[t]);
			index = t;	
		}
	}
	void add(int index, int nval) {
		if (nval == 0) {
			return;
		}
		h[rev[index]].first += nval;
		sift_up(rev[index]);
		sink_down(rev[index]);
	}
	void modify(int index, int nval) {
		if (nval == h[rev[index]].first) {
			return;
		}
		h[rev[index]].first = nval;
		sift_up(rev[index]);
		sink_down(rev[index]);
	}
	int value(int index) const {
		return h[rev[index]].first;
	}
	pair<int,int> top() const {
		return h[1];
	}
	void pop() {
		size_--;
		rev[h[size_+1].second] = 1;
		rev[h[1].second] = 0;
		h[1] = h[size_+1];
		sink_down(1);
	}
	inline int size() const {
		return size_;
	}
	int size_;
	vector<pair<int,int> > h;
	vector<int> rev;
};

struct solution {
	int x,y;
	vector<int> colors;
};

int move[4][2] = {{-1,0},{0,1},{1,0},{0,-1}};

int n;
const int max_color_size = 512;
int C;
vector<vector<int> > a;
ld start_time;
const ld time_bomb = 0.93;
void compute_connected(const vector<vector<int> >&b, vector<vector<int> > *res, vector<int> *broi) {
	int n = (int)b.size();
	int m = (int)b[0].size();
	res->resize(n);
	for (int i=0;i<n;++i){
		(*res)[i].resize(m, -1);
	}
	int num = 0;
	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			if ((*res)[i][j] != -1) {
				continue;
			}
			int ccolor = b[i][j];
			(*res)[i][j] = num;
			queue<pair<int,int> > tc;
			tc.push(mpair(i,j));
			while (!tc.empty()) {
				pair<int,int> cur = tc.front();tc.pop();
				for (int l=0;l<4;++l){
					int tx = cur.first + move[l][0];
					int ty = cur.second + move[l][1];
					if (tx < 0 || tx >= n || ty < 0 || ty >= m) {
						continue;
					}
					if (b[tx][ty] != ccolor || (*res)[tx][ty] != -1) {
						continue;
					}
					(*res)[tx][ty] = num;
					tc.push(mpair(tx,ty));
				}
			}
			num++;
		}
	}
	broi->resize(num, 0);
	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			for (int l=0;l<4;++l){
				int tx = i + move[l][0];
				int ty = j + move[l][1];
				int br = 0;
				if (tx >= 0 && tx < n && ty>= 0 && ty < n && (*res)[tx][ty] != (*res)[i][j]){
					(*broi)[(*res)[i][j]]++;		
				}
			}
		}
	}
}
int st[400*400],sz;
int diam[400*400], dsz;
int choose_begin(const vector<vector<int> >& b, int numcomps) {
	vector<vector<int> > ne(numcomps);
	int n = (int)b.size();
	int m = (int)b[0].size();
	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			int comp = b[i][j];
			for (int l = 0; l < 4; ++l) {
				int tx = i + move[l][0];
				int ty = j + move[l][1];
				if (tx < 0 || tx >= n || ty < 0 || ty >= m) {
					continue;
				}
				if (b[tx][ty] == comp) {
					continue;
				}
				ne[comp].push_back(b[tx][ty]);
			}
		}
	}
	vector<int> d(numcomps, -1);
	d[0] = 0;
	queue<int> tc;
	tc.push(0);
	int lastn;
	while (!tc.empty()) {
		int cur = tc.front();tc.pop();
		for (int i=0;i<(int)ne[cur].size();++i){
			if (d[ne[cur][i]] != -1) {
				continue;
			}
			d[ne[cur][i]] = d[cur] + 1;
			lastn = ne[cur][i];
			tc.push(ne[cur][i]);
		}
	}
	int other;
	fill(all(d), -1);
	d[lastn] = lastn;
	tc.push(lastn);
	while(!tc.empty()) {
		int cur = tc.front();tc.pop();
		for (int i=0;i<(int)ne[cur].size();++i){
			if (d[ne[cur][i]] != -1) {
				continue;
			}
			d[ne[cur][i]] = cur;
			other = ne[cur][i];
			tc.push(ne[cur][i]);
		}
	}
	dsz = 0;
	while(d[other] != other) {
		diam[dsz++]=other;
		other = d[other];
	}
	diam[dsz++] = other;
	return diam[dsz/2];
}

bool enough(const solution& res, int skip) {
	vector<vector<char> > b(a.size());
	for(int j=0;j<(int)a.size();++j){
		b[j].resize(a.size(),0);
	}
	queue<pair<int, int > > tc;
	int n = (int)a.size();
	int index = 0;
	vector<vector<pair<int,int> > > color_ne(C + 1);
	tc.push(mpair(res.x, res.y));
	int ccolor = a[res.x][res.y];
	while(!tc.empty()) {
		pair<int,int> cur = tc.front();tc.pop();
		for (int l=0;l<4;++l){
			int tx = cur.first + move[l][0];
			int ty = cur.second + move[l][1];
			if (tx < 0 || tx >= n || ty <0 || ty>= n) {
				continue;
			}
			if (a[tx][ty] == ccolor) {
				if(b[tx][ty] == 0){
					tc.push(mpair(tx,ty));
					b[tx][ty] = 1;
				}
			}else {
				if (b[tx][ty] == 2) {
					continue;
				}else {
					color_ne[a[tx][ty]].push_back(mpair(tx,ty));
					b[tx][ty] = 2;
				}
			}
		}
	}
	for (int index =0;index< (int)res.colors.size();++index) {
		if (index == skip) {
			continue;
		}
		ccolor = res.colors[index];
		for (int i=0;i<(int)color_ne[ccolor].size();++i){
			tc.push(color_ne[ccolor][i]);
			b[color_ne[ccolor][i].first][color_ne[ccolor][i].second] = 1;
		}
		color_ne[ccolor].clear();
		while(!tc.empty()) {
			pair<int,int> cur = tc.front();tc.pop();
			for (int l=0;l<4;++l){
				int tx = cur.first + move[l][0];
				int ty = cur.second + move[l][1];
				if (tx < 0 || tx >= n || ty <0 || ty>= n) {
					continue;
				}
				if (b[tx][ty] == 1 || b[tx][ty] == 2) {
					continue;
				}
				if (a[tx][ty] == ccolor) {
					if(b[tx][ty] == 0){
						tc.push(mpair(tx,ty));
						b[tx][ty] = 1;
					}
				}else {
					if (b[tx][ty] == 2) {
						continue;
					}else {
						color_ne[a[tx][ty]].push_back(mpair(tx,ty));
						b[tx][ty] = 2;
					}
				}
			}
		}
	}
	for (int i=0;i<n;++i){
		for (int j=0;j<n;++j){
			if (b[i][j] != 1) {
				return false;
			}
		}
	}
	return true;
}
void optimize(const solution& res, solution& optimal) {
	optimal = res;
	for (int i=(int)optimal.colors.size()-2;i>0;--i){
		if (get_time() - start_time > time_bomb) {
			break;
		}
		if (enough(optimal, i)) {
			optimal.colors.erase(optimal.colors.begin() + i);
			i--;
		}
	}
}

void solve2(solution& res) {
	vector<vector<int> > b = a;
	piramida colors(C + 1);
	vector<vector<int> > conected;
	vector<int> component;
	compute_connected(b, &conected, &component);
	int ncomp = (int)component.size();
	int combnumber = choose_begin(conected, ncomp);
	int index = dsz/2;
	vector<int> comp_color(ncomp);
	for (int i=0;i<(int)b.size();++i){
		for (int j=0;j<(int)b[0].size();++j){
			comp_color[conected[i][j]] = a[i][j];
			if (conected[i][j] == combnumber) {
				res.x = i;
				res.y = j;
			}
		}
	}
	sz = 0;
	int val=2;
	for (int i=res.x-1;i>=((val-1)*res.x)/val;--i){
		st[sz++] = a[i][res.y];
	}
	for (int i=res.x+1;i<=((int)b.size()+(val-1)*res.x)/val;++i){
		st[sz++] = a[i][res.y];
	}
	//for (int i=res.y-1;i>=((val-1)*res.y)/val;--i){
	//	st[sz++] = a[res.x][i];	
	//	//st[sz++] = comp_color[diam[i]];
	//}
	//for (int i=res.y+1;i<=((val-1)*res.y+(int)b.size())/val;++i){
	//	st[sz++] = a[res.x][i];	
	//	//st[sz++] = comp_color[diam[i]];
	//}

	vector<vector<pair<int,int> > > color_ne(C + 1);
	vector<char> added(ncomp, 0);
	queue<pair<int,int> > tc;

	tc.push(mpair(res.x, res.y));
	int ccolor = b[res.x][res.y];
	b[res.x][res.y] = -1;
	while(!tc.empty()) {
		pair<int,int> c = tc.front();tc.pop();
		for (int l = 0; l < 4;++l){
			int tx = c.first + move[l][0];
			int ty = c.second + move[l][1];
			if (tx < 0 || tx >= n || ty < 0 || ty >= n) {
				continue;
			}
			if (b[tx][ty] == -1 || b[tx][ty] == -2) {
				continue;
			}
			if (b[tx][ty] == ccolor) {
				tc.push(mpair(tx,ty));
				b[tx][ty] = -1;
				continue;
			} else {
				int comp_index = conected[tx][ty]; 
				if (!added[comp_index]) {
					colors.add(b[tx][ty], component[comp_index]);
					added[comp_index] = 1;
				}
				color_ne[b[tx][ty]].push_back(mpair(tx,ty));
				b[tx][ty] = -2;
			}
		}
	}

	int st_index = 0;
	while (colors.top().first != 0) {
		if (st_index < sz) {
			int ncolor = st[st_index];
			st_index++;
			if (colors.value(ncolor) != 0) {
				ccolor = ncolor;
			} else {
				continue;
			}
		} else {
			ccolor = colors.top().second;
		}

		res.colors.push_back(ccolor);
		queue<pair<int,int> > qu;
		for (int i=0;i<(int)color_ne[ccolor].size();++i) {
			qu.push(color_ne[ccolor][i]);
			b[color_ne[ccolor][i].first][color_ne[ccolor][i].second] = -1;
		}
		color_ne[ccolor].clear();
		colors.modify(ccolor, 0);
		while(!qu.empty()) {
			pair<int,int> c = qu.front();qu.pop();
			for (int l = 0; l < 4;++l){
				int tx = c.first + move[l][0];
				int ty = c.second + move[l][1];
				if (tx < 0 || tx >= n || ty < 0 || ty >= n) {
					continue;
				}
				if (b[tx][ty] == -1 /*|| b[tx][ty] == -2*/) {
					continue;
				}
				if (b[tx][ty] == -2) {
					colors.add(a[tx][ty], -1);
					continue;
				}
				if (b[tx][ty] == ccolor) {
					qu.push(mpair(tx,ty));
					b[tx][ty] = -1;
					continue;
				} else {
					int comp_index = conected[tx][ty];
					if (!added[comp_index] ) {
						colors.add(b[tx][ty], component[comp_index]);
						added[comp_index] = 1;
					}
					color_ne[b[tx][ty]].push_back(mpair(tx,ty));
					b[tx][ty] = -2;
				}
			}
		}
	}
}
void solve(solution& res, bool optimize = true,  int resx = -1, int resy = -1) {
	vector<vector<int> > b = a;
	piramida colors(C + 1);
	vector<vector<int> > conected;
	vector<int> component;
	compute_connected(b, &conected, &component);
	int ncomp = (int)component.size();
	if (resx == - 1 && resy == -1) {
		int combnumber = choose_begin(conected, ncomp);
		res.x = res.y = -1;
		for (int i=0;i<(int)b.size() && res.x == -1;++i){
			for (int j=0;j<(int)b[0].size();++j){
				if (conected[i][j] == combnumber) {
					res.x = i;
					res.y = j;
					break;
				}
			}
		}
	} else {
		res.x = resx;
		res.y = resy;
	}
	/*res.x = rander.rnd(n);
	res.y = rander.rnd(n);*/
	vector<vector<pair<int,int> > > color_ne(C + 1);
	vector<char> added(ncomp, 0);
	queue<pair<int,int> > tc;
	sz = 0;
	bool dont_do_lines = (n < 50 || C < 20)&&C<300; 
    if (!dont_do_lines) {
		for (int i=res.y-1;i>=0;i--){
			st[sz++] = res.x*10000 + i;
		}
		for (int i=res.y+1;i<n;++i){
 			st[sz++] = res.x*10000 + i;
		}
		if (C >= 35) {
			for (int i=res.x-1;i>=0;--i){
				st[sz++] = i*10000 + res.y;
			}
			for (int i=res.x+1;i<n;++i){
				st[sz++] = i*10000 + res.y;
			}
		}
		if (optimize) {
			for (int i=res.y-1;i>=0;i--){
				st[sz++] = 0 * 10000 + i;
				st[sz++] = (n-1) * 10000 + i;
			}
			for (int i=res.y+1;i<n;++i){
 				st[sz++] = (0)*10000 + i;
 				st[sz++] = (n-1)*10000 + i;
			}
			for (int i=res.x-1;i>=0;--i){
				st[sz++] = i*10000 + n - 1;
				st[sz++] = i*10000 + 0;
			}
			for (int i=res.x+1;i<n;++i){
				st[sz++] = i*10000 + 0;
				st[sz++] = i*10000 + n - 1;
			}
		}
	}
	tc.push(mpair(res.x, res.y));
	int ccolor = b[res.x][res.y];
	b[res.x][res.y] = -1;
	while(!tc.empty()) {
		pair<int,int> c = tc.front();tc.pop();
		for (int l = 0; l < 4;++l){
			int tx = c.first + move[l][0];
			int ty = c.second + move[l][1];
			if (tx < 0 || tx >= n || ty < 0 || ty >= n) {
				continue;
			}
			if (b[tx][ty] == -1 || b[tx][ty] == -2) {
				continue;
			}
			if (b[tx][ty] == ccolor) {
				tc.push(mpair(tx,ty));
				b[tx][ty] = -1;
				continue;
			} else {
				int comp_index = conected[tx][ty]; 
				if (!added[comp_index]) {
					colors.add(b[tx][ty], component[comp_index]);
					added[comp_index] = 1;
				}
				color_ne[b[tx][ty]].push_back(mpair(tx,ty));
				b[tx][ty] = -2;
			}
		}
	}
	//for (int i=1;i<=C;++i) {
	//	if (color_ne[i].size() != 0 ) {
	//		colors.modify(i, (int)color_ne[i].size());
	//	}
	//}

	int st_index = 0;
	while (colors.top().first != 0) {
		if (st_index < sz) {
			int xx = st[st_index]/10000;
			int yy = st[st_index]%10000;
			st_index++;
			if (colors.value(a[xx][yy]) != 0 &&b[xx][yy] != -1) {
				ccolor = a[xx][yy];
			} else {
				continue;
			}
		} else {
			ccolor = colors.top().second;
		}

		res.colors.push_back(ccolor);
		queue<pair<int,int> > qu;
		for (int i=0;i<(int)color_ne[ccolor].size();++i) {
			qu.push(color_ne[ccolor][i]);
			b[color_ne[ccolor][i].first][color_ne[ccolor][i].second] = -1;
		}
		color_ne[ccolor].clear();
		colors.modify(ccolor, 0);
		while(!qu.empty()) {
			pair<int,int> c = qu.front();qu.pop();
			for (int l = 0; l < 4;++l){
				int tx = c.first + move[l][0];
				int ty = c.second + move[l][1];
				if (tx < 0 || tx >= n || ty < 0 || ty >= n) {
					continue;
				}
				if (b[tx][ty] == -1 /*|| b[tx][ty] == -2*/) {
					continue;
				}
				if (b[tx][ty] == -2) {
					colors.add(a[tx][ty], -1);
					continue;
				}
				if (b[tx][ty] == ccolor) {
					qu.push(mpair(tx,ty));
					b[tx][ty] = -1;
					continue;
				} else {
					int comp_index = conected[tx][ty];
					if (!added[comp_index] ) {
						colors.add(b[tx][ty], component[comp_index]);
						added[comp_index] = 1;
					}
					color_ne[b[tx][ty]].push_back(mpair(tx,ty));
					b[tx][ty] = -2;
				}
			}
		}
	}
}
void optimize_me(solution& res){
	solution temp;
	optimize(res, temp);
	if (temp.colors.size() < res.colors.size()) {
		res = temp;
	}
}
#undef TOVA_E_KOMPIUTYRYT_NA_IVO

int main()
{
	freopen("flood-it.in","r",stdin);
	freopen("flood-it.out","w",stdout);
	start_time = get_time();
	cin >>  n >> C;
	a.resize(n);
	for (int i=0;i<n;++i){
		a[i].resize(n, 0);
		for (int j=0;j<n;j++){
			if (scanf("%d", &a[i][j]) == EOF) {
				cerr << "Small input!";
			}
			if (a[i][j] <=0 || a[i][j] > C) {
				cerr << "wrong input!" << endl;	
			}
		}
	}
	solution best;
	bool first = true;
	int lim = 1000;
	for (int i =0 ; true; ++i) {
		solution res;
		if (first) {
			solve(res);
			first = false;
			best = res;
		} else if (i == 1){
			int resx = (int)a.size()/2;//rander.rnd((unsigned)a.size());
			int resy = (int)a[0].size()/2;//rander.rnd((unsigned)a[0].size());
			solve(res, true, resx, resy);
			if (res.colors.size() < best.colors.size()) {
				best = res;
			}
		} else {
			ld dur = get_time() - start_time;
			if (i == 2 && best.colors.size() <1500 && dur < 0.2) {
				solve(res, false);
				if (res.colors.size() < best.colors.size()) {
					best = res;	
				}
				continue;
			}
			if (i == 4 && best.colors.size() <1500 && dur < 0.4) {
				int resx = (int)a.size()/2;//rander.rnd((unsigned)a.size());
				int resy = (int)a[0].size()/2;//rander.rnd((unsigned)a[0].size());
				solve(res, false, resx, resy);
				if (res.colors.size() < best.colors.size()) {
					best = res;
				}
				continue;
			}
			if (i > 30) {
				break;
			}
			if (dur + (dur/((ld)i-(ld)1)) > time_bomb) {
				break;
			}
			int resx,resy;
			if (a.size() > 50) {
				resx = (int)a.size()/3 + rander.rnd((unsigned)a.size()/3);
				resy = (int)a.size()/3 + rander.rnd((unsigned)a[0].size()/3);
			} else {
				resx = rander.rnd((ui)a.size());
				resy = rander.rnd((ui)a.size());
			}
			solve(res, (i%2==0), resx, resy);
			if (res.colors.size() < best.colors.size()) {
				best = res;
			}
		}

	}
	ld temp_time = get_time();
	optimize_me(best);
	printf("%d\n",(int)best.colors.size());
	printf("%d %d\n",best.x, best.y);
	for (int i=0;i<(int)best.colors.size();++i){
		printf("%d\n", best.colors[i]);
	}
#ifdef TOVA_E_KOMPIUTYRYT_NA_IVO
	ld total_time = get_time() - start_time;
	fprintf(stderr, "Total time: %.6Lf\n", total_time);
	
	if (total_time > 0.985) {
		while(get_time() - start_time < 1.3);
	}
#endif
	return 0;
}
